Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.turbine.modules.pages
Class TemplatePage

    java.lang.Object
      org.apache.turbine.modules.Assembler
          org.apache.turbine.modules.Page
              org.apache.turbine.modules.pages.DefaultPage
                  org.apache.turbine.modules.pages.TemplatePage

Direct Known Subclasses:
  JspPage, VelocityPage

    public class TemplatePage

extends DefaultPage

When building sites using templates, Screens need only be defined for templates which require dynamic (database or object) data.

This page can be used on sites where the number of Screens can be much less than the number of templates. The templates can be grouped in directories with common layouts. Screen modules are then expected to be placed in packages corresponding with the templates' directories and follow a specific naming scheme.

The template parameter is parsed and and a Screen whose package matches the templates path and shares the same name minus any extension and beginning with a capital letter is searched for. If not found, a Screen in a package matching the template's path with name Default is searched for. If still not found, a Screen with name Default is looked for in packages corresponding to parent directories in the template's path until a match is found.

For example if data.getParameters().getString("template") returns /about_us/directions/driving.wm, the search follows about_us.directions.Driving, about_us.directions.Default, about_us.Default, Default, WebMacroSiteScreen (i.e. the default screen set in TurbineResources).

Only one Layout module is used, since it is expected that any dynamic content will be placed in navigations and screens. The layout template to be used is found in a similar way to the Screen. For example the following paths will be searched in the layouts subdirectory: /about_us/directions/driving.wm, /about_us/directions/default.wm, /about_us/default.wm, /default.wm, where wm is the value of the template.default.extension property.

This approach allows a site with largely static content to be updated and added to regularly by those with little Java experience.

Version:
  $Id: TemplatePage.java 1078552 2011-03-06 19:58:46Z tv $
Author:
  John D. McNally, Dave Bryson, Henning P. Schmiedehausen, Peter Courcoux

Field Summary

Fields inherited from class org.apache.turbine.modules.pages.DefaultPage
`actionLoader, layoutLoader, log, screenLoader`

Fields inherited from class org.apache.turbine.modules.Page
`CACHE_SIZE_DEFAULT, CACHE_SIZE_KEY, NAME, PREFIX`

Constructor Summary
`TemplatePage()`

Method Summary
`protected void` | `doBuildAfterAction(PipelineData pipelineData)` Works with TemplateService to set up default templates and corresponding class modules.
`protected void` | `doBuildAfterAction(RunData data)` Works with TemplateService to set up default templates and corresponding class modules.

Methods inherited from class org.apache.turbine.modules.pages.DefaultPage
`doBuild, doBuild, doBuildBeforeAction, doBuildBeforeAction, doPostBuild, doPostBuild`

Methods inherited from class org.apache.turbine.modules.Page
`build, build, getPrefix`

Methods inherited from class org.apache.turbine.modules.Assembler
`getRunData`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TemplatePage

    public TemplatePage()

Method Detail

### doBuildAfterAction

    protected void doBuildAfterAction(RunData data)
                               throws Exception

  Works with TemplateService to set up default templates and corresponding class modules.

  Overrides:
    `doBuildAfterAction` in class `DefaultPage`
  Parameters:
    `data` - Turbine information.
  Throws:
    `Exception,` - a generic exception.
    `Exception`

### doBuildAfterAction

    protected void doBuildAfterAction(PipelineData pipelineData)
                               throws Exception

  Works with TemplateService to set up default templates and corresponding class modules.

  Overrides:
    `doBuildAfterAction` in class `DefaultPage`
  Parameters:
    `pipelineData` - Turbine information.
  Throws:
    `Exception,` - a generic exception.
    `Exception`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2011 The Apache Software Foundation. All Rights Reserved.